//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

// Copyright © 2006-2010 Travis Robinson. All rights reserved.
// Copyright © 2011-2018 LibUsbDotNet contributors. All rights reserved.
// 
// website: http://github.com/libusbdotnet/libusbdotnet
// 
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the
// Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA. or 
// visit www.gnu.org.
// 
//

using System;
using System.Runtime.InteropServices;

namespace LibUsbDotNet
{
    /// <summary>
    ///  A structure representing the standard USB endpoint descriptor. This
    ///  descriptor is documented in section 9.6.6 of the USB 3.0 specification.
    ///  All multiple-byte fields are represented in host-endian format.
    /// </summary>
    [StructLayoutAttribute(LayoutKind.Sequential, Pack = NativeMethods.Pack)]
    public unsafe struct EndpointDescriptor
    {
        /// <summary>
        ///  Size of this descriptor (in bytes)
        /// </summary>
        public byte Length;

        /// <summary>
        ///  Descriptor type. Will have value
        ///  this context.
        /// </summary>
        public byte DescriptorType;

        /// <summary>
        ///  The address of the endpoint described by this descriptor. Bits 0:3 are
        ///  the endpoint number. Bits 4:6 are reserved. Bit 7 indicates direction,
        ///  see
        /// </summary>
        public byte EndpointAddress;

        /// <summary>
        ///  Attributes which apply to the endpoint when it is configured using
        ///  the bConfigurationValue. Bits 0:1 determine the transfer type and
        ///  correspond to
        ///  isochronous endpoints and correspond to
        ///  Bits 4:5 are also only used for isochronous endpoints and correspond to
        /// </summary>
        public byte Attributes;

        /// <summary>
        ///  Maximum packet size this endpoint is capable of sending/receiving.
        /// </summary>
        public ushort MaxPacketSize;

        /// <summary>
        ///  Interval for polling endpoint for data transfers.
        /// </summary>
        public byte Interval;

        /// <summary>
        ///  For audio devices only: the rate at which synchronization feedback
        ///  is provided.
        /// </summary>
        public byte Refresh;

        /// <summary>
        ///  For audio devices only: the address if the synch endpoint
        /// </summary>
        public byte SynchAddress;

        /// <summary>
        ///  Extra descriptors. If libusb encounters unknown endpoint descriptors,
        ///  it will store them here, should you wish to parse them.
        /// </summary>
        public byte* Extra;

        /// <summary>
        ///  Length of the extra descriptors, in bytes.
        /// </summary>
        public int ExtraLength;

    }
}
